---
theme: default
_class: invert
_paginate: false
paginate: true
marp: true
style: |
  .columns {
    display: grid;
    grid-template-columns: repeat(2, minmax(0, 1fr));
    gap: 1rem;
  }
---
# **Variant Poker CFR and BR Design** <!-- fit -->
## PHIL Enchan

---
## define 1
$$
V_1(h) = \sum_{h_1 \in terminal(h)} \sum_{h2 \in opponent(h1)} evaluate_1(h_1, h_2)reach(h_1)reach(h_2)
$$

$$
V_1(h) = \sum_{h_1 \in next(h)} V_1(h_1)
$$
---
$$ 
V_1(Iso(h^\prime)) = \frac{\sum_{h\in Iso(h^\prime)}\sum_{h_1 \in terminal(h)} \sum_{h2 \in opponent(h1)} evaluate_1(h_1, h_2)}{\sum_{h\in Iso(h^\prime)}\sum_{h_1 \in terminal(h)} \sum_{h2 \in opponent(h1)}1}
$$

$$ 
V_1(Abstr(h^{\prime\prime})) = \frac{\sum_{Iso(h^\prime)\in Abstr(h^{\prime\prime})}\sum_{h\in Iso(h^\prime)}\sum_{h_1 \in terminal(h)} \sum_{h2 \in opponent(h1)} evaluate_1(h_1, h_2)}{\sum_{Iso(h^\prime)\in Abstr(h^{\prime\prime})}\sum_{h\in Iso(h^\prime)}\sum_{h_1 \in terminal(h)} \sum_{h2 \in opponent(h1)}1}
$$

---

## define 2
$$
V_1(h) = \sum_{h_1 \in terminal(h)} \sum_{h2 \in opponent(h1)} evaluate_1(h_1, h_2)reach(h, h_1)reach(h_2)
$$

$$
V_1(h) = \sum_{h_1 \in next(h)} V_1(h_1) reach(h, h_1)
$$

---

## define 2
同构具有perfect recall 的性质
$$ 
V_1(Iso(h^\prime)) = \sum_{h\in Iso(h^\prime)}\sum_{h_1 \in terminal(h)} \sum_{h2 \in opponent(h1)} evaluate_1(h_1, h_2)reach(h, h_1)reach(h_2)
$$

$$ 
\begin{aligned}
V_1(Iso(h^\prime)) &= \sum_{h\in Iso(h^\prime)}\sum_{h_1 \in next(h)}V_1(h_1) reach(h, h_1) \\
                   &= \sum_{h\in Iso(h^\prime)}\sum_{h_1 \in next(h)}V_1(h_1) reach(Iso(h^\prime), h_1)
\end{aligned}
$$
